package sets;


abstract class BasicNode<T> implements Node<T>
{
    private T item;      // value stored in node
    private int key;     // hash code of `item'

    public T item() {
        return this.item;
    }

    public int key() {
        return this.key;
    }

    public void setItem(T item) {
        this.item = item;
    }

    public boolean valid() {
        return true;
    }

    public boolean setValid() {
        return true;
    }

    public boolean setInvalid() {
        return false;
    }

    public void lock() {
        throw new UnsupportedOperationException("Method lock() is not implemented.");
    }

    public void unlock() {
        throw new UnsupportedOperationException("Method unlock() is not implemented.");
    }

    public boolean setNextIfValid(Node<T> expectNext, Node<T> newNext) {
        throw new UnsupportedOperationException("Method setNextIfValid() is not implemented.");
    }

    public Node<T> nextValid() {
        throw new UnsupportedOperationException("Method nextValid() is not implemented.");
    }

    // node with given `item'
    // and item.hashCode() as key
    BasicNode(T item) {
        this(item.hashCode());
        setItem(item);
    }

    // node with given `key' (and null item)
    BasicNode(int key) {
        this.key = key;
    }
}
